// HardLink.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "HardLink.h"
#include "HardLinkDlg.h"
#include "..\include\ErrorMsg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHardLinkApp

BEGIN_MESSAGE_MAP(CHardLinkApp, CWinApp)
	//{{AFX_MSG_MAP(CHardLinkApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHardLinkApp construction

CHardLinkApp::CHardLinkApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CHardLinkApp object

CHardLinkApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHardLinkApp initialization

BOOL CHardLinkApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

#ifndef _TESTUI
    // Verify we're running on a Win2k box.
    //
    OSVERSIONINFO osvi = { sizeof(osvi), 0 };
    GetVersionEx(&osvi);

    if( osvi.dwMajorVersion < 5 /* Win2k */ )
    {
        MessageBox( HWND_DESKTOP,
                    "This application must be run under Windows 2000.",
                    "Hard Link Utility",
                    MB_OK | MB_ICONERROR );

        return(FALSE);
    }
#endif

    // Valid command line options:
    //   /regserver                      Install this extension.
    //   /unregserver                    Uninstall this extension.
    //   /i:dummy_file_name              Interactive mode (invoked this way by the shell).
    //   /l:link_file /t:target_file     Command-line create a link command.
    //
    BOOL fSettingUp = FALSE;

    if( !strcmpi(&m_lpCmdLine[1], "regserver") )
    {
        Install();
        fSettingUp = TRUE;
    }
    else if( !strcmpi(&m_lpCmdLine[1], "unregserver") )
    {
        Uninstall();
        fSettingUp = TRUE;
    }

    if( fSettingUp )
    {
        // We're done.
        return(FALSE);
    }

    BOOL fCmdLineOkay = FALSE;  // One of the valid command line arg sets was found.
    BOOL fShellInvoke = FALSE;  // App was invoked by the shell using /i flag.
                                // Else, app was invoked from and command shell using the /l:link_file /t:target_file options.
    char *pszLinkFile = 0;
    char *pszTargetFile = 0;

    if( !_strnicmp(m_lpCmdLine, "/i:", 3) )
    {
        fCmdLineOkay = TRUE;
        fShellInvoke = TRUE;
        pszLinkFile  = &m_lpCmdLine[3];
    }
    else if( !_strnicmp(m_lpCmdLine, "/l:", 3) )
    {
        pszLinkFile = &m_lpCmdLine[3];
        pszTargetFile = strstr(pszLinkFile, "/t:");

        if( !pszTargetFile ) pszTargetFile = strstr(pszLinkFile, "/T:");

        if( pszTargetFile )
        {
            *(pszTargetFile - 1) = 0;
            pszTargetFile += 3;
            fCmdLineOkay = TRUE;
        }
    }

    if( !fCmdLineOkay )
    {
        MessageBox( HWND_DESKTOP,
                    "Invalid command line.\n\n"
                    "To install this utility: HardLink.exe /regserver\n"
                    "To uninstall this utility: HardLink.exe /unregserver\n"
                    "Command-line invocation: HardLink.exe /l:link_file_name /t:target_file_name\n",
                    "Hard Link Utility",
                    MB_OK | MB_ICONERROR );

        return(FALSE);
    }

    if( fShellInvoke )
    {
        // Invoked by the shell.

        // Delete the .hlk file that the shell created.  We don't
        // want the file around, we just want the directory portion
        // of this filename's path.  Under NT 4, the file is actually
        // created.  Under Win2k (RC1), the file is not created, even
        // though the filename is passed.  Just to be safe, we'll call
        // DeleteFile, since any failure is harmless.
        //
        DeleteFile(pszLinkFile);
    	    
        // Crack out the directory information from the filename that
        // was passed to us.
        //
        char szDrive[_MAX_DRIVE + 1];
        char szPath[_MAX_PATH + 1];

        _splitpath(pszLinkFile, szDrive, szPath, 0, 0);
        sprintf(m_szLinkDir, "%s%s", szDrive, szPath);

        SetCurrentDirectory(m_szLinkDir);

        // Proceed.
        //
	    CHardLinkDlg dlg;
	    m_pMainWnd = &dlg;
	    int nResponse = dlg.DoModal();
	    if (nResponse == IDOK)
	    {
		    // TODO: Place code here to handle when the dialog is
		    //  dismissed with OK
	    }
	    else if (nResponse == IDCANCEL)
	    {
		    // TODO: Place code here to handle when the dialog is
		    //  dismissed with Cancel
	    }
    }
    else
    {
        // Invoked manually with command line arguments for
        // the link filename and the target filename.
        //
#ifndef _TESTUI
        if( !CreateHardLink(pszLinkFile, pszTargetFile, 0) )
        {
            ErrorMessage("CreateHardLink");
        }
#else
        CString strMsg;

        strMsg.Format( "Create link %s that refers to %s.",
                       pszLinkFile, pszTargetFile );
        MessageBox(HWND_DESKTOP, strMsg, "Hard Link Utility", MB_OK);
#endif
    }

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

char g_szLaunchCmd[MAX_PATH + 32];

CHardLinkApp::REGSETUP CHardLinkApp::s_rgSetupKeys[] =
{
    { ".hlk", "", "HardLink" },
    { ".hlk\\ShellNew", "Command", g_szLaunchCmd },
    { "HardLink", "", "Hard Link" },
    { "HardLink\\shell", "", "" },
    { "HardLink\\shell\\open", "", "" },
    { "HardLink\\shell\\open\\command", "", "." }
};

int CHardLinkApp::s_cKeys = sizeof(CHardLinkApp::s_rgSetupKeys) / sizeof(CHardLinkApp::s_rgSetupKeys[0]);

void CHardLinkApp::Install( void )
{
    g_szLaunchCmd[0] = '\"';
    GetModuleFileName(0, &g_szLaunchCmd[1], MAX_PATH);
    strcat(g_szLaunchCmd, "\" /i:%1");

    LONG lResult = ERROR_SUCCESS;
    HKEY hkey;

    for( int iKey = 0; (ERROR_SUCCESS == lResult) && (iKey < s_cKeys); iKey++ )
    {
        lResult = RegCreateKey(HKEY_CLASSES_ROOT, s_rgSetupKeys[iKey].pszKeyName, &hkey);

        if( ERROR_SUCCESS == lResult )
        {
            lResult = RegSetValueEx( hkey, s_rgSetupKeys[iKey].pszValueName, 0,
                                     REG_SZ, (LPBYTE)s_rgSetupKeys[iKey].pszValueState,
                                     strlen(s_rgSetupKeys[iKey].pszValueState) + 1 );
            RegCloseKey(hkey);
        }
    }

    if( lResult != ERROR_SUCCESS )
    {
        Uninstall();
    }
}

void CHardLinkApp::Uninstall( void )
{
    for( int iKey = s_cKeys - 1; iKey >= 0; iKey-- )
    {
        RegDeleteKey(HKEY_CLASSES_ROOT, s_rgSetupKeys[iKey].pszKeyName);
    }
}

BOOL CHardLinkApp::CreateHardLink( const char *pszLinkFile, const char *pszTargetFile, LPSECURITY_ATTRIBUTES psa /*=0*/ )
{
    BOOL        fOutcome = FALSE;
    HINSTANCE   hinstKernel32 = LoadLibrary("kernel32.dll");

    if( hinstKernel32 )
    {
        typedef BOOL (WINAPI *PFXNCREATEHARDLINK)( const char *pszLinkFile,
                                                   const char *pszTargetFile,
                                                   LPSECURITY_ATTRIBUTES psa );

        PFXNCREATEHARDLINK pfxnCreateHardLink;

        pfxnCreateHardLink = (PFXNCREATEHARDLINK)
            GetProcAddress(hinstKernel32, "CreateHardLinkA");

        if( pfxnCreateHardLink )
        {
            fOutcome = pfxnCreateHardLink(pszLinkFile, pszTargetFile, psa);
        }

        FreeLibrary(hinstKernel32);
    }

    return(fOutcome);
}

BOOL CHardLinkApp::VolumeSupportsHardLinks( char *pszFile )
{
    DWORD   dwVolFlags;
    BOOL    fOkay;
    char    szDrive[4];

    ZeroMemory(szDrive, sizeof(szDrive));
    strncpy(szDrive, pszFile, 3);

    fOkay = GetVolumeInformation( szDrive,
                                  0, 0,
                                  0, 0, &dwVolFlags,
                                  0, 0 );

    if( !fOkay || !(dwVolFlags & FILE_SUPPORTS_REPARSE_POINTS) )
    {
        fOkay = FALSE;
    }

    return(fOkay);
}
