// HardLink Utility
//
// Copyright (c) 2000 Mike Woodring
// http://www.bearcanyon.com
//
#include "stdafx.h"
#include "HardLink.h"
#include "HardLinkDlg.h"
#include "..\include\ErrorMsg.h"
#include "_BldNum.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_strVersionText;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_strVersionText = _T("");
	//}}AFX_DATA_INIT

    m_strVersionText.Format( "HardLink %d.%d.%d.%d",
                             FILE_VERSION0, FILE_VERSION1, FILE_VERSION2,
                             BUILD_NUMBER );
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_VERSIONTEXT, m_strVersionText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHardLinkDlg dialog

CHardLinkDlg::CHardLinkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHardLinkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHardLinkDlg)
	m_strLinkFileName = _T("");
	m_strSourceFileName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHardLinkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHardLinkDlg)
	DDX_Text(pDX, IDC_LINKFILENAME, m_strLinkFileName);
	DDX_Text(pDX, IDC_SOURCEFILENAME, m_strSourceFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHardLinkDlg, CDialog)
	//{{AFX_MSG_MAP(CHardLinkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnCreateLink)
	ON_BN_CLICKED(IDC_BROWSEFILE, OnBrowseFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHardLinkDlg message handlers

BOOL CHardLinkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
    CHardLinkApp *pApp = (CHardLinkApp *)AfxGetApp();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHardLinkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHardLinkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHardLinkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHardLinkDlg::OnCreateLink() 
{
	// TODO: Add your control notification handler code here

    if( UpdateData(TRUE) )
    {
        char szSourceFileName[MAX_PATH];
        char szLinkFileName[MAX_PATH];

        if( strchr(m_strLinkFileName, '\\') )
        {
            strcpy(szLinkFileName, m_strLinkFileName);
        }
        else
        {
            CHardLinkApp *pApp = (CHardLinkApp *)AfxGetApp();

            sprintf( szLinkFileName, "%s%s",
                     pApp->m_szLinkDir, m_strLinkFileName );
        }

        if( strchr(m_strSourceFileName, '\\') )
        {
            strcpy(szSourceFileName, m_strSourceFileName);
        }
        else
        {
            CHardLinkApp *pApp = (CHardLinkApp *)AfxGetApp();

            sprintf( szSourceFileName, "%s%s",
                     pApp->m_szLinkDir, m_strSourceFileName );
        }

        if( !CHardLinkApp::VolumeSupportsHardLinks(szSourceFileName) ||
            !CHardLinkApp::VolumeSupportsHardLinks(szLinkFileName) )
        {
            MessageBox( "One or both of the volumes specified does not support hard links.",
                        "Hard Link Utility", MB_OK | MB_ICONERROR );
            return;
        }

#ifndef _TESTUI
        if( !CHardLinkApp::CreateHardLink(szLinkFileName, szSourceFileName, 0) )
        {
            ErrorMessage("CreateHardLink");
        }
#else
        CString strMsg;

        strMsg.Format( "Create link %s that refers to %s.",
                       szLinkFileName, (const char *)m_strSourceFileName );
        MessageBox(strMsg);
#endif
    }

    CDialog::OnOK();	
}

void CHardLinkDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CHardLinkDlg::OnBrowseFile() 
{
    if( UpdateData(TRUE) )
    {
        OPENFILENAME    OpenFileName;
        char            szFile[512];

        strcpy(szFile, m_strSourceFileName);

        ZeroMemory(&OpenFileName, sizeof(OpenFileName));
    
        OpenFileName.lStructSize    = sizeof(OpenFileName);
        OpenFileName.hwndOwner      = this->GetSafeHwnd();
        OpenFileName.lpstrFilter    = "All Files\0*.*\0";
        OpenFileName.nFilterIndex   = 1;
        OpenFileName.lpstrFile      = szFile;
        OpenFileName.nMaxFile       = sizeof(szFile) / sizeof(szFile[0]);
        OpenFileName.lpstrTitle     = "Browse To Target File";
        OpenFileName.lpstrDefExt    = 0;
        OpenFileName.Flags          = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;

        if( GetOpenFileName(&OpenFileName) )
        {
            m_strSourceFileName = szFile;
            UpdateData(FALSE);
        }
    }
}

